#
# defaults
#
ifndef ATH_CAP_SUPERG_FF
export ATH_CAP_SUPERG_FF=0
endif

ifndef ATH_CAP_DYNTURBO
export ATH_CAP_DYNTURBO=0
endif

ifndef ATH_CAP_SUPERG_COMP
export ATH_CAP_SUPERG_COMP=0
endif

ifndef ATH_CAP_XR
export ATH_CAP_XR=0
endif

ifndef ATH_CAP_TPC
export ATH_CAP_TPC=0
endif

ifndef ATH_CAP_CWM
export ATH_CAP_CWM=1
endif

ifndef ATH_CHAINMASK_SELECT
export ATH_CHAINMASK_SELECT=1
endif

ifndef ATH_FORCE_PPM
export ATH_FORCE_PPM=0
endif

ifndef ATH_FORCE_BIAS
export ATH_FORCE_BIAS=0
endif

ifndef AR5416_EMULATION
export AR5416_EMULATION=0
endif

ifndef AR9100
export AR9100=0
endif

ifndef ATH_RXBUF
export ATH_RXBUF=512
endif

ifndef AH_CAL_IN_FLASH
export AH_CAL_IN_FLASH=0
endif

ifndef AH_SUPPORT_DFS
export AH_SUPPORT_DFS=1
endif

ifndef ATH_TX_INACT_TIMER
export ATH_TX_INACT_TIMER=0
endif

ifndef ATH_WPS_IE
export ATH_WPS_IE=1
endif

ifndef CONFIG_SMP
    ifndef ATH_CAP_AMSDU
        export ATH_CAP_AMSDU=1
    endif
else
    export ATH_CAP_AMSDU=0
endif

ifndef ATH_SUPPORT_UAPSD
export ATH_SUPPORT_UAPSD=1
endif

ifndef BUILD_AP
export BUILD_AP=1
endif

ifndef IEEE80211_MCAST_ENHANCEMENT
export IEEE80211_MCAST_ENHANCEMENT=1
endif

ifndef ATH_SUPPORT_IQUE
export ATH_SUPPORT_IQUE=0
endif

ifndef NO_SIMPLE_CONFIG
export NO_SIMPLE_CONFIG=0
endif

ifndef ATH_DEFINE_ENDIAN
export ATH_DEFINE_ENDIAN=1
endif

ifndef ATH_SUPPORT_STA
export ATH_SUPPORT_STA=0
endif

ifndef ATH_RFKILL
export ATH_RFKILL=0
endif

ifndef ATH_MIB_INTR_FILTER
export ATH_MIB_INTR_FILTER=0
endif

ifndef ATH_SUPPORT_EEEPC
export ATH_SUPPORT_EEEPC=0
endif

ifndef ATH_AUTOCREATE_MODE
export ATH_AUTOCREATE_MODE="none"
endif
#
# directives
#
ifeq ($(strip ${ATH_SUPPORT_STA}),1)
COPTS+= -DATH_SUPPORT_STA=1
endif

ifeq ($(strip ${ATH_RFKILL}),1)
COPTS+= -DATH_RFKILL=1
endif

ifeq ($(strip ${ATH_MIB_INTR_FILTER}),1)
COPTS+= -DATH_MIB_INTR_FILTER=1
endif

ifeq ($(strip ${ATH_SUPPORT_EEEPC}),1)
COPTS+= -DATH_SUPPORT_EEEPC=1
endif

ifneq ($(strip ${ATH_CAP_SUPERG_FF}),0)
COPTS+= -DATH_SUPERG_FF=1
endif

ifneq ($(strip ${ATH_CAP_DYNTURBO}),0)
COPTS+= -DATH_SUPERG_DYNTURBO=1 -DATH_TURBO_SCAN=1
endif

ifneq ($(strip ${ATH_CAP_SUPERG_COMP}),0)
COPTS+= -DATH_SUPERG_COMP=1
endif

ifneq ($(strip ${ATH_CAP_XR}),0)
COPTS+= -DATH_SUPERG_XR=1
endif

ifneq ($(strip ${ATH_CAP_TPC}),0)
COPTS+= -DATH_CAP_TPC=1
endif

ifneq ($(strip ${ATH_CAP_CWM}),0)
COPTS+= -DATH_CWM=1
endif

ifneq ($(strip ${ATH_CHAINMASK_SELECT}),0)
COPTS+= -DATH_CHAINMASK_SELECT=1
endif

ifneq ($(strip ${ATH_FORCE_PPM}),0)
COPTS+= -DATH_FORCE_PPM=1
endif

ifneq ($(strip ${ATH_FORCE_BIAS}),0)
COPTS+= -DATH_FORCE_BIAS=1
endif

ifneq ($(strip ${AR5416_EMULATION}),0)
COPTS+= -DAR5416_EMULATION=1
endif

ifneq ($(strip ${AR9100}),0)
COPTS+= -DAR9100=1
endif

COPTS+= -DATH_RXBUF=${ATH_RXBUF}

ifneq ($(strip ${ATH_SUPPORT_DFS}),0)
COPTS+= -DATH_SUPPORT_DFS=1
endif

ifneq ($(strip ${ATH_TX_INACT_TIMER}),0)
COPTS+= -DATH_TX_INACT_TIMER=1
endif

ifneq ($(strip ${AH_CAL_IN_FLASH}),0)
COPTS+= -DAH_CAL_IN_FLASH=1 -DAH_CAL_RADIOS=${AH_CAL_RADIOS} -DAH_CAL_LOCATIONS=${AH_CAL_LOCATIONS}
endif

ifneq ($(strip ${ATH_RB}),0)
COPTS+= -DATH_RB=1
endif

ifneq ($(strip ${ATH_CAP_AMSDU}),0)
COPTS+= -DATH_AMSDU=1
endif

ifneq ($(strip ${ATH_SUPPORT_UAPSD}),0)
COPTS+= -DATH_SUPPORT_UAPSD=1
endif

ifneq ($(strip ${BUILD_AP}),0)
COPTS+= -DBUILD_AP=1
endif

ifneq ($(strip ${IEEE80211_MCAST_ENHANCEMENT}),0)
COPTS+= -DIEEE80211_MCAST_ENHANCEMENT=1
endif

ifneq ($(strip ${ATH_SUPPORT_IQUE}),0)
COPTS+= -DATH_SUPPORT_IQUE=1
endif

ifneq ($(strip ${ATH_WPS_IE}),0)
COPTS+= -DATH_WPS_IE=1
endif

ifneq ($(strip ${NO_SIMPLE_CONFIG}),0)
COPTS+= -DNO_SIMPLE_CONFIG=1
endif

ifdef ATH_AUTOCREATE_MODE
COPTS+= -DATH_AUTOCREATE_MODE='${ATH_AUTOCREATE_MODE}'
endif

